searchNodes=[{"doc":"Prism is a simple local message broker.With this module, you can subscribe handlers to topics. When an event is published to the broker - any subscriber of that topic will have its handler function called. This permits simple event-driven mechanisms to be implemented within applications.Prism avoids the use of processes when publishing events to subscribers. In that sense - handlers are all invoked in the publishing process. If you wish something to be done &quot;out of band&quot; from the publisher - you will be resposibsle for the implementation.Exampledefmodule MyBroker do use Prism def start_link(subscribers \\\\ []) do Prism.start_link(name: __MODULE__, subscribers: subscribers) end def subscribe(handler_id, topic_or_topics, handler) do Prism.subscribe(__MODULE__, handler_id, topic_or_topics, handler) end def publish(topic, event) do Prism.publish(__MODULE__, topic, event) end end defmodule Callback do def call(topic, event) do IO.inspect(topic) IO.inspect(event) :ok end end # Start the broker MyBroker.start_link() # Subscribe a handler MyBroker.subscribe(&quot;my_handler&quot;, [:my, :topic], &amp;Callback.call/2) # Publish to a topic MyBroker.publish([:my, :topic], &quot;hello&quot;)","ref":"Prism.html","title":"Prism","type":"module"},{"doc":"Deletes a handler from the broker.Handlers that are deleted will no longer recieve events that are published to the broker.Examplesiex&gt; Prism.subscribe(:my_broker, &quot;my_handler&quot;, [:foo, :bar], &amp;Callback.call/2) :ok iex&gt; Prism.delete(:my_broker, &quot;my_handler&quot;) :ok","ref":"Prism.html#delete/3","title":"Prism.delete/3","type":"function"},{"doc":"Publishes an event to subscribers of the given topic.Publishing is done in a syncronous manner within the calling process. If you need work to be done &quot;out of bound&quot; of the publisher - its your responsibility to implement it in that way. Any exceptions raised by a handler will also propagate to the publisher.This will return a list of results in the format {handler_id, result}, where result is what is returned by the handler.Examplesiex&gt; Prism.subscribe(:my_broker, &quot;my_handler&quot;, [:foo, :bar], fn topic, event -&gt; {topic, event} end) :ok iex&gt; Prism.publish(:my_broker, [:foo, :bar], &quot;hello&quot;) [{&quot;my_handler&quot;, {[:foo, :bar], &quot;hello&quot;}}]","ref":"Prism.html#publish/3","title":"Prism.publish/3","type":"function"},{"doc":"Starts a message broker process.Options:name - The name of the broker process.:subscribers - A list of subscribers to start the broker with.","ref":"Prism.html#start_link/1","title":"Prism.start_link/1","type":"function"},{"doc":"Subscribes a handler to a topic or topics within the broker.handler_id must be unique. If another handler with the same ID already exists then {:error, :already_exists} is returned. topic_or_topics is a list or list of lists containing atoms that describe an event occurance. handler is a 2-arity function that is called when an event is published to a subscribed topic.Due to how anonymous functions are implemented in the Erlang VM, it is best to use function captures (i.e. &amp;Mod.fun/2) as handlers to achieve maximum performance. In other words, avoid using literal anonymous functions (fn ... -&gt; ... end) or local function captures (&amp;handle_event/2) as handlers.Please see publish/3 for information on publishing to subscribers.Examplesiex&gt; Prism.subscribe(:my_broker, &quot;my_handler&quot;, [:foo, :bar], &amp;Callback.call/2) :ok iex&gt; Prism.subscribe(:my_broker, &quot;my_handler&quot;, [:foo, :bar], &amp;Callback.call/2) {:error, :already_exists} iex&gt; Prism.subscribe(:my_broker, &quot;my_other_handler&quot;, [[:foo, :bar], [:bar, :baz]], &amp;Callback.call/2) :ok","ref":"Prism.html#subscribe/5","title":"Prism.subscribe/5","type":"function"},{"doc":"The unique broker identifier","ref":"Prism.html#t:broker_id/0","title":"Prism.broker_id/0","type":"type"},{"doc":"The custom payload sent to event handlers","ref":"Prism.html#t:event/0","title":"Prism.event/0","type":"type"},{"doc":"A function invoked when publishing events","ref":"Prism.html#t:handler/0","title":"Prism.handler/0","type":"type"},{"doc":"The unique event handler identifier","ref":"Prism.html#t:handler_id/0","title":"Prism.handler_id/0","type":"type"},{"doc":"Option values used by start_link/1","ref":"Prism.html#t:option/0","title":"Prism.option/0","type":"type"},{"doc":"Options used by start_link/1","ref":"Prism.html#t:options/0","title":"Prism.options/0","type":"type"},{"doc":"The result of a publish for a single event handler","ref":"Prism.html#t:result/0","title":"Prism.result/0","type":"type"},{"doc":"The result of a publish","ref":"Prism.html#t:results/0","title":"Prism.results/0","type":"type"},{"doc":"A tuple used to describe a subscriber","ref":"Prism.html#t:subscriber/0","title":"Prism.subscriber/0","type":"type"},{"doc":"A list of subscribers","ref":"Prism.html#t:subscribers/0","title":"Prism.subscribers/0","type":"type"},{"doc":"The name of a topic","ref":"Prism.html#t:topic/0","title":"Prism.topic/0","type":"type"},{"doc":"A list of topics","ref":"Prism.html#t:topics/0","title":"Prism.topics/0","type":"type"},{"doc":"PrismPrism is a simple local message broker.","ref":"readme.html","title":"Prism","type":"extras"},{"doc":"The package can be installed by adding prism to your list of dependencies in mix.exs:def deps do [ {:prism, &quot;~&gt; 0.1&quot;} ] end","ref":"readme.html#installation","title":"Prism - Installation","type":"extras"},{"doc":"Please see HexDocs for additional documentation.","ref":"readme.html#documentation","title":"Prism - Documentation","type":"extras"},{"doc":"With Prism, you can subscribe handlers to topics. When an event is published to the broker - any subscriber of that topic will have its handler function called. This permits simple event-driven mechanisms to be implemented within applications.Prism avoids the use of processes when publishing events to subscribers. In that sense - handlers are all invoked syncronously withinin the publishing process. If you wish something to be done &quot;out of band&quot; from the publisher - you will be resposibsle for the implementation.defmodule MyBroker do # Adds the child_spec/1 callback required to use under a Supervisor use Prism def start_link(subscribers \\\\ []) do Prism.start_link(name: __MODULE__, subscribers: subscribers) end def subscribe(handler_id, topic_or_topics, handler) do Prism.subscribe(__MODULE__, handler_id, topic_or_topics, handler) end def publish(topic, event) do Prism.publish(__MODULE__, topic, event) end end defmodule Callback do def call(topic, event) do IO.inspect(topic) IO.inspect(event) :ok end end # Start the broker MyBroker.start_link() # Subscribe a handler MyBroker.subscribe(&quot;my_handler&quot;, [:my, :topic], &amp;Callback.call/2) # Publish to a topic MyBroker.publish([:my, :topic], &quot;hello&quot;)","ref":"readme.html#getting-started","title":"Prism - Getting Started","type":"extras"}]